/*
Licensed Materials - Property of IBM
5725-C95
 Copyright IBM Corporation 2012. All Rights Reserved.
US Government Users Restricted Rights- Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

// Contains all utilities that Coach runtime supports validation

define([], function() {
				
	// holds all the constants used by framework, those constants are visible in the generated html
	var CONSTANTS = {
		// css class names
		CONTENT_BOX:		"ContentBox",
		COACH_VIEW:			"CoachView",
		COACH_VIEW_SHOW:	"CoachView_show",
		COACH_VIEW_HIDDEN:	"CoachView_hidden",
		TOP_LEVEL:			"topLevel",
		CONTENTBOX_TEMPLATE:"ContentBoxTemplate",
		COACH_VIEW_WARNING:	"CoachView_warning",
	
		// attribute names
		VIEW_ID:			"data-viewId",
		VIEW_DATA_TYPE:		"data-type",
		DATA_BINDING:		"data-binding",
		DATA_BINDING_RT:	"data-bindingRT",
		DATA_CONFIG:		"data-config",
		IS_VIEW_MANAGED:	"data-view-managed",
		TEMPLATE_ID:		"templateId",
		
		// internal constants
		COACH_SHIMMER_ID_BASE:	"coachViewShimmer",
		TYPE_COACH:				"type_coach",
		TYPE_VIEW:				"type_view",
		TYPE_FWK_CONTENTBOX:	"type_fwk_contentBox",
		TYPE_VIEW_CONTENTBOX:	"type_view_contentBox",
		
		// validation event
		VALIDATION_EVENT_TYPE_ERROR:	"error",
		VALIDATION_EVENT_TYPE_CLEAR:	"clear",
		
		//
		CURRENT_ITEM:		"index",
		
		// millisecond
		ELAPSED_TIME_THRESHOLD_LOAD: 100,
		ELAPSED_TIME_THRESHOLD_UNLOAD: 50,
		ELAPSED_TIME_THRESHOLD_VIEW: 50,
		ELAPSED_TIME_THRESHOLD_CHANGE: 50,
		ELAPSED_TIME_THRESHOLD_COLLABORATION: 50,
		ELAPSED_TIME_THRESHOLD_VALIDATE: 50,
			
		// following 4 are used to specify the location of view instance in the DOM tree
		TOPLEVEL_VIEW_ID:	"topLevelViewId",
		VIEW_PATH:			"viewPath",
		SUBVIEW_ID:			"subviewId",
		SUBVIEW_INDEX:		"subviewIndex"
		
	};
	
	
	return CONSTANTS;
});
	