/*
Licensed Materials - Property of IBM
5725-C95
 Copyright IBM Corporation 2012. All Rights Reserved.
US Government Users Restricted Rights- Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

// Contains all common utilities

define(["dojo/_base/kernel","./CONSTANTS"], function(dojoKernel, CONSTANTS) {
				
	var commonHelper = new Object();
	
	commonHelper.INFO = "info";
	commonHelper.WARN = "warn";
	commonHelper.ERROR = "error";
	commonHelper.LOG = "log";
	
	// this API write the message directly to browser's console as long as browser's console exists
	commonHelper.consoleLog = function(message, type) {
		if(!console) {
			return;
		}
		
		if(commonHelper.INFO === type && !!console.info) {
			console.info(message);
		} else if(commonHelper.WARN === type && !!console.warn) {
			console.warn(message);
		} else if(commonHelper.ERROR === type && !!console.error) {
			console.error(message);
		} else if(!!console.log){
			console.log(message);
		}
	}
	
	commonHelper.timestamp = function(action) {
		if(commonHelper.isDebugMode()) {
			commonHelper.consoleLog("Performance: " + (new Date()).getTime() + " -- " + action, commonHelper.INFO);
		}
	}
	
	commonHelper.isDebugMode = function() {
		if(!!dojoKernel.config) {
			return dojoKernel.config.isDebug;
		}
		
		return false;
	}

	commonHelper.getDojoVersion = function() {
		return dojoKernel.version;
	}	
		
	commonHelper.timestamp("commonHelper is created");

	// print out the dojo version, which may help view developer and support since the dojo version used by coach framework is not fixed per release.
	commonHelper.consoleLog("dojo version used by Coach is: " + commonHelper.getDojoVersion(), commonHelper.INFO);
	
	return commonHelper;
});
